# 2.16.x Release Series

## 2.16.0.dev1 (Nov 27, 2022)

### New Features

* go: address sanitizer support ([#17651](https://github.com/pantsbuild/pants/pull/17651))

* go: add support for C/C++ memory sanitizer ([#17644](https://github.com/pantsbuild/pants/pull/17644))

* shell: add `experimental_test_shell_command` for arbitrary shell-driven tests ([#17640](https://github.com/pantsbuild/pants/pull/17640))

* support Go data race detector ([#17510](https://github.com/pantsbuild/pants/pull/17510))

* Add `Field.none_is_valid_value` bool class var option. ([#17577](https://github.com/pantsbuild/pants/pull/17577))

### User API Changes

* Remove deprecated `run --cleanup` option. ([#17647](https://github.com/pantsbuild/pants/pull/17647))

* Upgrade Pex to 2.1.116. ([#17637](https://github.com/pantsbuild/pants/pull/17637))

### Plugin API Changes

* Remove deprecated Platform.current. ([#17646](https://github.com/pantsbuild/pants/pull/17646))

### Bug fixes

* Fix twine env vars propagation for `publish` goal. ([#17650](https://github.com/pantsbuild/pants/pull/17650))

* Support `source=None` for `docker_image` targets. ([#17578](https://github.com/pantsbuild/pants/pull/17578))

* Specify local environment for python source analysis goal ([#17603](https://github.com/pantsbuild/pants/pull/17603))

* go: allow use of `go_asm.h` assembly header in assembly files ([#17611](https://github.com/pantsbuild/pants/pull/17611))

* Visibility rule glob tweaks for `*` and `**` ([#17588](https://github.com/pantsbuild/pants/pull/17588))

### Documentation

* Fix broken docs links to manual build instructions ([#17608](https://github.com/pantsbuild/pants/pull/17608))

* Docs: improve docs on handling option values in cli ([#17506](https://github.com/pantsbuild/pants/pull/17506))

## 2.16.0.dev0 (Nov 19, 2022)

### New Features

* Add `environment=` to `experimental_shell_command`. ([#17575](https://github.com/pantsbuild/pants/pull/17575))

* Add debug goals to python ([#17057](https://github.com/pantsbuild/pants/pull/17057))

* Target visibility rules ([#17401](https://github.com/pantsbuild/pants/pull/17401))

* Emit a `__run.sh` into InteractiveProcess sandboxes. ([#17532](https://github.com/pantsbuild/pants/pull/17532))

* Support newer pip versions. ([#17555](https://github.com/pantsbuild/pants/pull/17555))

* New dependency rules Plugin API ([#17550](https://github.com/pantsbuild/pants/pull/17550))

* Export metadata about a packaged docker image ([#17299](https://github.com/pantsbuild/pants/pull/17299))

* Don't require hardcoded name in `python_distribution.provides` ([#17522](https://github.com/pantsbuild/pants/pull/17522))

* Add `per_platform` object ([#17334](https://github.com/pantsbuild/pants/pull/17334))

* Process output capturing is symlink-aware ([#17496](https://github.com/pantsbuild/pants/pull/17496))

* go: introduce `GoBuildOptions` and `cgo_enabled` field ([#17475](https://github.com/pantsbuild/pants/pull/17475))

* Disambiguate Python module providers by level of ancestry. ([#17489](https://github.com/pantsbuild/pants/pull/17489))

* go: support ".syso" prebuilt object files ([#17479](https://github.com/pantsbuild/pants/pull/17479))

* Add Docker registries `use_local_alias` configuration option. ([#17265](https://github.com/pantsbuild/pants/pull/17265))

* Proposal for supporting Jar shading rules ([#17251](https://github.com/pantsbuild/pants/pull/17251))

* A --resolve flag, to specify the resolves to export. ([#17416](https://github.com/pantsbuild/pants/pull/17416))

* Handle duplicate JAR entries in `deploy_jar` ([#17419](https://github.com/pantsbuild/pants/pull/17419))

### User API Changes

* Upgrade default version of  golangci-lint to 1.50.1 ([#17574](https://github.com/pantsbuild/pants/pull/17574))

* Deprecate the old export semantics. ([#17465](https://github.com/pantsbuild/pants/pull/17465))

* Add `restartable` field to `python_sources` ([#17400](https://github.com/pantsbuild/pants/pull/17400))

* Deprecate the `# Dependees` column name in the py-constraints summary. ([#17399](https://github.com/pantsbuild/pants/pull/17399))

* Rename the dependees goal to dependents. ([#17397](https://github.com/pantsbuild/pants/pull/17397))

* Rename --changed-dependees to --changed-dependents ([#17395](https://github.com/pantsbuild/pants/pull/17395))

### Bug fixes

* Allow for `run --debug-adapter` to match breakpoints when source is running in a sandbox ([#17566](https://github.com/pantsbuild/pants/pull/17566))

* Created an `NpxToolBase` as an inheritable Subsystem for `nodejs` tools ([#17567](https://github.com/pantsbuild/pants/pull/17567))

* Fix loading of `SymlinkNodes` from the `Store`. ([#17549](https://github.com/pantsbuild/pants/pull/17549))

* Do not try to create `""` output directory in `CreateArchive` ([#17538](https://github.com/pantsbuild/pants/pull/17538))

* Persist digests before emitting them in `fs_util` ([#17525](https://github.com/pantsbuild/pants/pull/17525))

* Fix memoization of `CoarsenedTarget.closure` ([#17516](https://github.com/pantsbuild/pants/pull/17516))

* Support parsing targets from additional paths not containing BUILD files. ([#17451](https://github.com/pantsbuild/pants/pull/17451))

* Ensure lockfile target exists before injecting a dependency to it. ([#17365](https://github.com/pantsbuild/pants/pull/17365))

* Ensure correct eq/hash semantics for PythonArtifact. ([#17484](https://github.com/pantsbuild/pants/pull/17484))

* Isolate config seed values from the DEFAULT section. ([#17474](https://github.com/pantsbuild/pants/pull/17474))

* Fix poorly understood stdout redirection issue. ([#17471](https://github.com/pantsbuild/pants/pull/17471))

* Fix propagation of the remote-execution-append-only-caches path  ([#17469](https://github.com/pantsbuild/pants/pull/17469))

* Pyright should grab non-transitive dependencies and make them available in the sandbox ([#17235](https://github.com/pantsbuild/pants/pull/17235))

* Plumb symlink support through the Pants engine ([#16844](https://github.com/pantsbuild/pants/pull/16844))

* Flip the default for `pull` on `docker_image` to `False` ([#17459](https://github.com/pantsbuild/pants/pull/17459))

* Merge pytest addopts ([#16614](https://github.com/pantsbuild/pants/pull/16614))

* Fix dep inference from `shuint2_tests` targets. ([#17417](https://github.com/pantsbuild/pants/pull/17417))

* Fix `EnvironmentName` used in `test` runs ([#17412](https://github.com/pantsbuild/pants/pull/17412))

* Add the m1 homebrew bin dir to the system binary search path. ([#17411](https://github.com/pantsbuild/pants/pull/17411))

* Restore debug hints for `test` execution ([#17406](https://github.com/pantsbuild/pants/pull/17406))

### Performance

* Skip loading of local cache data when possible ([#17495](https://github.com/pantsbuild/pants/pull/17495))

* Symlink site-packages into `pylint` venvs when possible. ([#17488](https://github.com/pantsbuild/pants/pull/17488))

* Filter coarsened targets to only those that are relevant in `pylint` runner rule ([#17487](https://github.com/pantsbuild/pants/pull/17487))

### Documentation

* correct docs: direnv can't save ulimit ([#17561](https://github.com/pantsbuild/pants/pull/17561))

* Update team pages for SJ and Dan! ([#17534](https://github.com/pantsbuild/pants/pull/17534))

* Fix line breaks in a docs page. ([#17527](https://github.com/pantsbuild/pants/pull/17527))

* Clarify how `__defaults__` apply to target generators. ([#17493](https://github.com/pantsbuild/pants/pull/17493))

* Fix typo in docs: debug-adaptor should be debug-adapter ([#17452](https://github.com/pantsbuild/pants/pull/17452))

* Update `nuke_if_too_big` documentation ([#17429](https://github.com/pantsbuild/pants/pull/17429))

* Fix version templating in `vcs_version` docs ([#17423](https://github.com/pantsbuild/pants/pull/17423))
